#ifndef _RECORD_H_
#define _RECORD_H_

#include <iostream>
#include <vector>

using namespace std;

//Shame on me! :)
typedef unsigned long long CountInteger;

struct Record
{
	int numOfWords;
	CountInteger ngramCount;
	vector<string> words;

	Record();
	Record( int );
	Record( const CountInteger&, const vector<string>& );
	Record( const Record& );

	bool match( const vector<string>& ) const;

	Record& operator=( const Record& );
	bool operator==( const Record& ) const;
	bool operator<( const Record& ) const;


	friend istream& operator>>( istream&, Record& );
	friend ostream& operator<<( ostream&, const Record& );
};

#endif
